﻿/**
 * Method invoker:
 * http://stackoverflow.com/questions/13411194/getting-error-system-invalidoperationexception-was-unhandled
 */

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;

namespace AudibleChatClient
{
    public partial class connect : Form
    {
        // Chris
        Login login;

        public static Listen listener;


        public connect()
        {
            InitializeComponent();

            // Chris
            listener = new Listen();
            login = new Login();

            listener.addCallback(Protocol.SC_USERCONNECT_SUCCESS, onConnectSuccess);
            listener.addCallback(Protocol.SC_USERCONNECT_FAIL, onConnectFail);
        }

        private void btnConnect_Click(object sender, EventArgs e)
        {
            _connect();
        }

        public void _connect()
        {
            // Chris
            try
            {
                btnConnect.Enabled = false;
                txtPort.Enabled = false;
                txtHost.Enabled = false;
                lblHost.Enabled = false;
                lblPort.Enabled = false;
                labelConnectionStatus.Text = "Connecting...";

                if (!listener.waiting)
                {
                    IPAddress _ip = IPAddress.Parse(txtHost.Text);
                    listener.initConnection(Convert.ToInt32(txtPort.Text), _ip);

                    if (listener != null && !listener.isListening)
                    {

                        if (listener.startListening())
                        {
                            byte[] CS = new byte[2];
                            CS[0] = 0x01;
                            CS[1] = Protocol.CS_USERCONNECT;
                            listener.sendMessage(CS);

                            listener.waiting = true;

                            return;
                        }
                    }
                }

                btnConnect.Enabled = true;
                txtPort.Enabled = true;
                txtHost.Enabled = true;
                lblHost.Enabled = true;
                lblPort.Enabled = true;
                labelConnectionStatus.Text = "Failed";
                
                
            }
            catch (Exception e)
            {
                Console.WriteLine("connect._connect() failed: " + e.Message);
                MessageBox.Show("Could not connect to the provided IP Address and Port");
            }
        }

        private void _connect_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 13)
            {
                _connect();
                e.Handled = true;
            }
        }

        private int onConnectSuccess(byte[] bytes)
        {
            if (InvokeRequired)
            {
                Listen.messageReceiveCallback d = new Listen.messageReceiveCallback(onConnectSuccess);
                this.Invoke(d, new object[] { bytes });

                return Protocol.CS_FAILURE;
            }
            else
            {
                listener.waiting = false;
                labelConnectionStatus.Text = "Connected!";
                login.Show();
                this.Hide();
                return Protocol.CS_SUCCESS;
            }
        }

        private int onConnectFail(byte[] bytes)
        {
            if (InvokeRequired)
            {
                Listen.messageReceiveCallback d = new Listen.messageReceiveCallback(onConnectFail);
                this.Invoke(d, new object[] { bytes });

                return Protocol.CS_FAILURE;
            }
            else
            {
                listener.waiting = false;
                labelConnectionStatus.Text = "Connection Failed";
                MessageBox.Show("Connection failed");
                return Protocol.CS_SUCCESS;
            }
        }

        private void connect_Load(object sender, EventArgs e)
        {

        }

        private void connect_FormClosed(object sender, FormClosedEventArgs e)
        {
            listener.removeCallback(Protocol.SC_USERCONNECT_SUCCESS, onConnectSuccess);
            listener.removeCallback(Protocol.SC_USERCONNECT_FAIL, onConnectFail);
        }

        public static void restartProgram()
        {
            MethodInvoker mi = delegate
            {
                Application.Restart();
            };
            if (connect.ActiveForm.InvokeRequired)
                connect.ActiveForm.Invoke(mi);
        }

        public static void endProgram()
        {
            MethodInvoker mi = delegate
            {
                //listener.stopListening();
                Application.Exit();
            };
            if (connect.ActiveForm.InvokeRequired)
                connect.ActiveForm.Invoke(mi);
        }
    }
}
