﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using DataBaseTest;

namespace AudibleChatClient
{
    public partial class CreateUser : Form
    {
        Login parent;
        Encoding asciiEncoder = Encoding.ASCII;

        public CreateUser(Login parent)
        {
            InitializeComponent();
            this.parent = parent;

            // Chris
            connect.listener.addCallback(Protocol.SC_USERREGISTER_SUCCESS, onRegisterSuccess);
            connect.listener.addCallback(Protocol.SC_USERREGISTER_FAIL, onRegisterFail);
        }

        private void btnCreate_Click(object sender, EventArgs e)
        {
            _register();
        }

        // Chris
        private int onRegisterSuccess(byte[] bytes)
        {
            if (InvokeRequired)
            {
                Listen.messageReceiveCallback d = new Listen.messageReceiveCallback(onRegisterSuccess);
                this.Invoke(d, new object[] { bytes });

                return Protocol.CS_FAILURE;
            }
            else
            {
                MessageBox.Show("Registration successful!");
                this.Close();

                return Protocol.CS_SUCCESS;
            }
        }

        // Chris
        private int onRegisterFail(byte[] bytes)
        {
            if (InvokeRequired)
            {
                Listen.messageReceiveCallback d = new Listen.messageReceiveCallback(onRegisterFail);
                this.Invoke(d, new object[] { bytes });

                return Protocol.CS_FAILURE;
            }
            else
            {
                MessageBox.Show("Registration failed. Please check your connection and try again.");

                return Protocol.CS_SUCCESS;
            }
        }

        private void _register_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 13)
            {
                _register();
                e.Handled = true;
            }
        }

        private void _register()
        {
            if (txtUN.Text == "" || txtPW1.Text == "" || txtPW2.Text == "")
            {
                MessageBox.Show("You must fill out all fields");
            }
            else if (txtPW1.Text != txtPW2.Text)
            {
                MessageBox.Show("Your passwords must match");
            }
            else if (txtPW1.Text.Count() > Protocol.SIZE_PASSWORD || txtUN.Text.Count() > Protocol.SIZE_USERNAME)
            {
                MessageBox.Show("Both your username and passwords must be " + Protocol.SIZE_USERNAME + " characters or less");
            }
            else
            {
                parent.userName = txtUN.Text;
                parent.passWord = txtPW1.Text;

                List<byte> msg = new List<byte>();
                msg.Add(0x01);
                msg.Add(Protocol.CS_USERREGISTER);

                byte[] usr = new byte[Protocol.SIZE_USERNAME];
                ASCIIEncoding.ASCII.GetBytes(txtUN.Text).ToList().CopyTo(usr);
                msg.AddRange(usr.ToList());

                byte[] pw = new byte[Protocol.SIZE_PASSWORD_HASH];
                ASCIIEncoding.ASCII.GetBytes(PassHash.HashPass(txtPW1.Text)).ToList().CopyTo(pw);
                msg.AddRange(pw.ToList());

                connect.listener.sendMessage(msg.ToArray());
            }
        }

        private void CreateUser_FormClosed(object sender, FormClosedEventArgs e)
        {
            connect.listener.removeCallback(Protocol.SC_USERREGISTER_SUCCESS, onRegisterSuccess);
            connect.listener.removeCallback(Protocol.SC_USERREGISTER_FAIL, onRegisterFail);
        }
    }
}
