﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace AudibleChatClient
{
    public partial class JoinRoom : Form
    {
        PublicRoom parent;

        public JoinRoom(PublicRoom parent)
        {
            InitializeComponent();

            this.parent = parent;

            connect.listener.addCallback(Protocol.SC_USERJOINREQUEST_SUCCESS, onJoiningRoomSuccess);
            connect.listener.addCallback(Protocol.SC_USERJOINREQUEST_FAIL, onJoiningRoomFail);
        }

        private void _join()
        {
            List<byte> msg = new List<byte>();
            msg.Add(0x01);
            msg.Add(Protocol.CS_USERJOINREQUEST);

            byte[] room = new byte[Protocol.SIZE_ROOMNAME];
            ASCIIEncoding.ASCII.GetBytes(txtRoomName.Text).ToList().CopyTo(room);
            msg.AddRange(room.ToList());

            connect.listener.sendMessage(msg.ToArray());
        }

        private void btnJoin_Click(object sender, EventArgs e)
        {
            _join();
        }

        private void txtRoomName_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 13)
            {
                _join();
            }
        }

        public int onJoiningRoomSuccess(byte[] bytes)
        {
            if (InvokeRequired)
            {
                Listen.messageReceiveCallback d = new Listen.messageReceiveCallback(onJoiningRoomSuccess);
                this.Invoke(d, new object[] { bytes });

                return Protocol.CS_FAILURE;
            }
            else
            {
                parent.roomName = txtRoomName.Text;
                parent.joinRoom(txtRoomName.Text);

                this.Close();

                return Protocol.CS_SUCCESS;
            }
        }

        private int onJoiningRoomFail(byte[] bytes)
        {
            if (InvokeRequired)
            {
                Listen.messageReceiveCallback d = new Listen.messageReceiveCallback(onJoiningRoomFail);
                this.Invoke(d, new object[] { bytes });

                return Protocol.CS_FAILURE;
            }
            else
            {
                MessageBox.Show("Failed to join room: " + txtRoomName.Text);
                return Protocol.CS_SUCCESS;
            }

        }

        private void JoinRoom_FormClosed(object sender, FormClosedEventArgs e)
        {
            connect.listener.removeCallback(Protocol.SC_USERJOINREQUEST_SUCCESS, onJoiningRoomSuccess);
            connect.listener.removeCallback(Protocol.SC_USERJOINREQUEST_FAIL, onJoiningRoomFail);
        }
    }
}
