﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Security.Cryptography;

namespace DataBaseTest
{
    static class PassHash
    {
        /// <summary>
        /// Takes a string and hashes it.
        /// </summary>
        /// <param name="password">The password to hash.</param>
        /// <returns>Returns the hashed password with the bytes used to salt it at the end.</returns>
        public static string HashPass(string password)
        {
            byte[] saltyBytes = { Convert.ToByte(''), Convert.ToByte('-'), Convert.ToByte('Ô'), Convert.ToByte('Þ'), Convert.ToByte('+') };
            //converts the password into a byte array
            byte[] passBytes = Encoding.UTF8.GetBytes(password);
            //if (saltyBytes == null)
            //{
            //    //creates the salt for the hash to make it more secure
            //    saltyBytes = new Byte[new Random().Next(3, 5)];
            //    RNGCryptoServiceProvider rng = new RNGCryptoServiceProvider();
            //    rng.GetNonZeroBytes(saltyBytes);
            //}

            //creates the byte array with the password + the salt at the end of it
            byte[] saltyPass = new byte[passBytes.Length + saltyBytes.Length];
            Array.Copy(passBytes, saltyPass, passBytes.Length);
            for (int i = 0; i < saltyBytes.Length; i++)
                saltyPass[passBytes.Length + i] = saltyBytes[i];

            //Hashes the password + salt
            byte[] hashedBytes = new SHA512Managed().ComputeHash(saltyPass);

            //takes the original salt and adds it to the end of the hashed pass with salt for use in checking test passwords against it
            byte[] hashSalt = new byte[hashedBytes.Length + saltyBytes.Length];
            Array.Copy(hashedBytes, hashSalt, hashedBytes.Length);
            for (int i = 0; i < saltyBytes.Length; i++)
                hashSalt[hashedBytes.Length + i] = saltyBytes[i];

            //Converts the new hashed pass with salt + salt into a string and returns it
            return Convert.ToBase64String(hashSalt);
        }

        /// <summary>
        /// Makes a comparison of a nonhashed string with a hashed string.
        /// </summary>
        /// <param name="testPass">The password to be checked.</param>
        /// <param name="hashedPass">The hashed password to be checked against.</param>
        /// <returns>Returns true if the passwords match, else it will return false.</returns>
        public static bool CheckPass(string testPass, string hashedPass)
        {
            //byte[] passBytes = Encoding.UTF8.GetBytes(password);
            byte[] hashPass = Convert.FromBase64String(hashedPass);

            //this is how many bytes are in a SHA512 hash.
            int hashSize = 64;

            //grabs the salty bytes from the end of the hashedPass
            byte[] saltBytes = new byte[hashPass.Length - hashSize];
            for (int i = 0; i < saltBytes.Length; i++)
                saltBytes[i] = hashPass[hashSize + i];

            //Returns true is the password is the same, else return false
            return (HashPass(testPass) == hashedPass);
        }
    }
}
