﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AudibleChatClient
{
    public abstract class Protocol
    {
        public const uint SIZE_USERNAME = 16;
        public const uint SIZE_PASSWORD = 16;
        public const uint SIZE_PASSWORD_HASH = 92;
        public const uint SIZE_ROOMNAME = 16;
        public const uint SIZE_USERTXT = SIZE_USERNAME + 2 + 128;
        public const uint SIZE_IPTXT = 15;
        //public const uint SIZE_AUDIOCHUNK = 0;

        /************************************
         * SC == Server Send to Client
         * CS == Client Send to Server
         ************************************/

        /// <summary>
        /// Messages client sends to server
        /// </summary>
        public const int CS_FAILURE = 0x00;
        public const int CS_SUCCESS = 0x01;
        public const int CS_KEEPALIVE = 0x02;
        public const int CS_USERCONNECT = 0x03;
        public const int CS_USERREGISTER = 0x04;
        public const int CS_USERLOGIN = 0x05;
        public const int CS_USERLOGOUT = 0x06;
        public const int CS_ROOMCREATE = 0x07;
        public const int CS_ADDMEMBER = 0x08;
        public const int CS_REMOVEMEMBER = 0x09;
        public const int CS_USERTXT = 0x0A;
        public const int CS_TOKENREQUEST = 0x0B;
        public const int CS_TOKENHOLD = 0x0C;
        public const int CS_TOKENRELEASE = 0x0D;
        public const int CS_USERLISTREQUEST = 0x0E;
        public const int CS_AUDIOSETUP = 0x0F;
        public const int CS_AUDIOCHUNK = 0x10;
        public const int CS_USERJOINREQUEST = 0x11;
        public const int CS_USERLEAVEREQUEST = 0x12;
        public const int CS_ROOMLISTREQUEST = 0x13;


        /// <summary>
        /// Messages server sends to client
        /// </summary>
        public const int SC_FAILURE = 0x00;
        public const int SC_SUCCESS = 0x01;
        public const int SC_KEEPALIVE = 0x02;

        public const int SC_USERCONNECT_FAIL = 0x03;
        public const int SC_USERCONNECT_SUCCESS = 0x04;

        public const int SC_USERLOGIN_FAIL = 0x05;
        public const int SC_USERLOGIN_SUCCESS = 0x06;

        public const int SC_USERLOGOUT_FAIL = 0x07;
        public const int SC_USERLOGOUT_SUCCESS = 0x08;

        public const int SC_USERREGISTER_FAIL = 0x09;
        public const int SC_USERREGISTER_SUCCESS = 0x0A;

        public const int SC_USERJOIN = 0x0B;
        public const int SC_USERLEAVE = 0x0C;
        public const int SC_USERTXT = 0x0D;
        public const int SC_USERLIST = 0x0E;

        public const int SC_ROOMCREATE_FAIL = 0x0F;
        public const int SC_ROOMCREATE_SUCCESS = 0x10;

        public const int SC_ADDMEMBER_FAIL = 0x11;
        public const int SC_ADDMEMBER_SUCCESS = 0x12;

        public const int SC_REMOVEMEMBER_FAIL = 0x13;
        public const int SC_REMOVEMEMBER_SUCCESS = 0x14;

        public const int SC_TOKENREQUEST_FAIL = 0x15;
        public const int SC_TOKENREQUEST_SUCCESS = 0x16;

        public const int SC_TOKENHOLD_FAIL = 0x17;
        public const int SC_TOKENHOLD_SUCCESS = 0x18;

        public const int SC_AUDIOBEGIN = 0x19;
        public const int SC_AUDIOEND = 0x1A;

        public const int SC_USERJOINREQUEST_FAIL = 0x1B;
        public const int SC_USERJOINREQUEST_SUCCESS = 0x1C;

        public const int SC_USERLEAVEREQUEST_FAIL = 0x1D;
        public const int SC_USERLEAVEREQUEST_SUCCESS = 0x1E;

        public const int SC_ROOMLIST = 0x1F;
    }
}
