﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace AudibleChatClient
{
    public partial class RoomSpecs : Form
    {
        Encoding asciiEncoder = Encoding.ASCII;

        public RoomSpecs()
        {
            InitializeComponent();

            connect.listener.addCallback(Protocol.SC_ROOMCREATE_FAIL, onRoomCreateFail);
            connect.listener.addCallback(Protocol.SC_ROOMCREATE_SUCCESS, onRoomCreateSuccess);
            connect.listener.addCallback(Protocol.SC_USERLIST, onUsersPopulate);
        }

        private void btnCreate_Click(object sender, EventArgs e)
        {
            createRoom();
            this.Hide();
        }

        public void createRoom()
        {
            byte[] room = new byte[2 + Protocol.SIZE_ROOMNAME];
            room[0] = 0x01;
            room[1] = Protocol.CS_ROOMCREATE;

            asciiEncoder.GetBytes(txtRoomName.Text, 0, txtRoomName.Text.Length, room, 2);

            connect.listener.sendMessage(room);
        }

        private void _create_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (txtRoomName.Text.Length >= Protocol.SIZE_ROOMNAME)
            {
                txtRoomName.Text.Remove((int)Protocol.SIZE_ROOMNAME - 1);
                e.Handled = true;
            }

            if (e.KeyChar == 13)
            {
                createRoom();
                this.Hide();
            }
        }

        private int onRoomCreateFail(byte[] bytes)
        {
            MessageBox.Show("Could not create room " + txtRoomName.Text);
            return Protocol.CS_SUCCESS;
        }

        private int onUsersPopulate(byte[] bytes)
        {
            return Protocol.CS_FAILURE;
        }

        private int onRoomCreateSuccess(byte[] bytes)
        {
            MessageBox.Show("Room " + txtRoomName.Text + " successfully created.");
            this.Close();
            return Protocol.CS_SUCCESS;
        }

        private void btnUsers_Click(object sender, EventArgs e)
        {

        }

        private void RoomSpecs_FormClosed(object sender, FormClosedEventArgs e)
        {
            connect.listener.removeCallback(Protocol.SC_ROOMCREATE_FAIL, onRoomCreateFail);
            connect.listener.removeCallback(Protocol.SC_ROOMCREATE_SUCCESS, onRoomCreateSuccess);
            connect.listener.removeCallback(Protocol.SC_USERLIST, onUsersPopulate);
        }

        private void txtRoomName_PreviewKeyDown(object sender, PreviewKeyDownEventArgs e)
        {

        }

        private void RoomSpecs_Load(object sender, EventArgs e)
        {
            txtRoomName.Focus();
        }
    }
}
