﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.Diagnostics;
using System.IO.Ports;
using System.IO;
using System.Data;
using System.Drawing;
using System.Windows.Forms;
using System.Windows;

namespace AudibleChatClient
{


    public class keepAlive
    {

        private Thread _keepAliveThread;
        private Stopwatch _keepAliveTimer;
        UdpClient client;

        public bool keep = false;

        public keepAlive(UdpClient _client)
        {
            client = _client;

            keep = false;

            _keepAliveTimer = new Stopwatch();

            _keepAliveThread = new Thread(keepAliveCallback);
            _keepAliveThread.Name = "Keep Alive Thread";
            _keepAliveThread.IsBackground = true;
            _keepAliveThread.Start();
        }

        private void keepAliveCallback()
        {
            try
            {
                bool run = true;

                while (run)
                {
                    if (_keepAliveTimer.IsRunning)
                    {
                        
                        if (_keepAliveTimer.Elapsed.Seconds >= 15)
                        {
                            MessageBox.Show("Connection to the server has timed out");

                            connect.listener.stopListening();

                            keep = false;

                            run = false;
                            connect.endProgram();
                        }
                        else
                        {
                            try
                            {
                                if (keep)
                                {
                                    byte[] pack = new byte[2];
                                    pack[0] = 0x01;
                                    pack[1] = Protocol.CS_KEEPALIVE;

                                    connect.listener.sendMessage(pack);

                                    Console.WriteLine("sent keepAlive");

                                    _keepAliveTimer.Reset();

                                    keep = false;

                                    Thread.Sleep(3000);
                                }
                            }
                            catch (Exception e)
                            {
                                Console.WriteLine("send keepalive failed: " + e.Message);
                            }
                        }
                    }
                    else
                    {
                        _keepAliveTimer.Restart();
                    }
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("keepalive exception: " + e.Message);
            }
        }
    }
}
