﻿/*
 * Chris Logsdon
 * CP 252 Final Project
 * Audio Chat Server
 * 
 * Partners:
 * Zack Wheeler (Database, Documentation, Overseer)
 * Gina MacIntyre (Client)
 * 
 * Credits:
 * 
 * List Box Item color change:
 * http://stackoverflow.com/questions/6896151/c-sharp-change-listbox-items-color
 * http://stackoverflow.com/questions/3663704/how-to-change-listbox-selection-background-color
 * 
 * Log Delegates
 * http://stackoverflow.com/questions/8808395/thread-safe-updates-of-a-winform-control-from-other-classes
 * 
 * Log Scroll to End
 * http://stackoverflow.com/questions/739656/how-can-i-scroll-to-a-specified-line-in-a-winforms-textbox-using-c
 */

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace AudioChatServer
{
    public partial class LogWindow : Form
    {
        MainForm parent;

        private delegate void LogMessage(string msg);

        public LogWindow(MainForm parent)
        {
            InitializeComponent();

            this.parent = parent;
        }

        public void logMessage(string msg)
        {
            if (txtLog.InvokeRequired)
            {
                LogMessage d = new LogMessage(logMessage);
                this.Invoke(d, new object[] { msg });
            }
            else
            {
                txtLog.Text += msg + "\n";

                int position = 0;

                for (int i = 0; i < txtLog.Lines.Length; i++)
                {
                    position += txtLog.Lines[i].Length;
                }

                txtLog.SelectionStart = position;

                txtLog.ScrollToCaret();
            }
        }

        private void LogWindow_FormClosing(object sender, FormClosingEventArgs e)
        {
            this.Hide();

            e.Cancel = true;
        }

        private void txtLog_KeyPress(object sender, KeyPressEventArgs e)
        {
            parent.onKeyPress(sender, e);
            e.Handled = true;
        }
    }
}
