CREATE DATABASE IF NOT EXISTS chatty;
USE chatty;
DROP TABLE IF EXISTS R_U, Rooms, U_P, Users, Pwrd;

CREATE TABLE IF NOT EXISTS Users
(
	u_id INT UNSIGNED NOT NULL AUTO_INCREMENT,
	u_name VARCHAR(16) NOT NULL UNIQUE,
	PRIMARY KEY (u_id)
);

CREATE TABLE IF NOT EXISTS Pwrd
(
	p_id INT UNSIGNED NOT NULL AUTO_INCREMENT,
	phash VARCHAR(92) NOT NULL,
	PRIMARY KEY (p_id)
);

CREATE TABLE IF NOT EXISTS U_P
(
	u_id INT UNSIGNED NOT NULL,
	p_id INT UNSIGNED NOT NULL,
	FOREIGN KEY (u_id) REFERENCES Users(u_id),
	FOREIGN KEY (p_id) REFERENCES Pwrd(p_id),
	PRIMARY KEY (u_id, p_id)
);

CREATE TABLE IF NOT EXISTS Rooms
(
	r_id INT UNSIGNED NOT NULL AUTO_INCREMENT,
	r_name VARCHAR(16) UNIQUE,
	u_id INT UNSIGNED NOT NULL,
	FOREIGN KEY (u_id) REFERENCES Users(u_id),
	PRIMARY KEY (r_id)
);

CREATE TABLE IF NOT EXISTS R_U
(
	r_id INT UNSIGNED NOT NULL,
	u_id INT UNSIGNED NOT NULL,
	FOREIGN KEY (r_id) REFERENCES Rooms(r_id),
	FOREIGN KEY (u_id) REFERENCES Users(u_id),
	PRIMARY KEY (r_id, u_id)
);